Subject: Re: [PATCH v3 net-next] net: multipath routing: configurable seed

From: Pavel Balaev <[email-masked]>
Date: Thu, 15 Apr 2021 11:20:46 +0300

On Wed, Apr 14, 2021 at 08:24:11PM -0700, David Ahern wrote:
> On 4/14/21 12:33 AM, Pavel Balaev wrote:
> >>
> >> This should work the same for IPv6.
> > I wanted to add IPv6 support after IPv4 will be approved,
> > anyway no problem, will add IPv6 in next version 
> >> And please add test cases under tools/testing/selftests/net.
> > This feature cannot be tested whithin one host instance, becasue the same seed
> > will be used by default for all netns, so results will be the same
> > anyway, should I use QEMU for this tests?
> >  
> > 
> 
> why not make the seed per namespace?
In patch seed is maked per namespace. I mean that I cannot check default
behaviour whitin one host: sysctl net.ipv4.fib_multipath_hash_seed=random.
In this case system random seed will be used (same for all netns,
as it was before my patch).

We can only test two cases:

netns0: net.ipv4.fib_multipath_hash_seed=${SEED_0}
netns1: net.ipv4.fib_multipath_hash_seed=${SEED_1}

flows direction will not be the same.

netns0: net.ipv4.fib_multipath_hash_seed=${SEED_0}
netns1: net.ipv4.fib_multipath_hash_seed=${SEED_0}

flows direction will be the same.

Is this enough?